require 'json'
require 'rest-client'
require 'set'
require 'uri'

require 'essential/version'
require 'essential/client'

# Resources
require 'essential/resource'
require 'essential/resource/paginator_proxy'

# Top-level Resources
require 'essential/account'

# Messaging Resources
require 'essential/messaging/message'
require 'essential/messaging/transport'
require 'essential/messaging/subscriber'
require 'essential/messaging/channel'

module Essential
  @api_base = 'https://api.essential.to'
  @utc_offset = nil

  class << self
    attr_accessor :api_base, :sid, :token, :utc_offset
  end

  include Client
end
