module Essential
  class Account < Resource
    include Essential::Resource::Update

    attr_property :name, :token, :unsubscribed_send_raises, :created_at, :updated_at
    attr_schema created_at: Time, updated_at: Time

    def self.retrieve(opts={}, headers: {})
      me = self.new(headers: headers)
      me.fetch
      me
    end

    def self.url
      "/v2/account"
    end

    def initialize(sid: nil, headers: nil, attrs: nil)
      sid ||= Essential.sid

      super(sid: sid, headers: headers, attrs: attrs)
    end

    def url
      self.class.url
    end

    def channels
      Essential::Resource::PaginatorProxy.new(Essential::Messaging::Channel, headers: @headers)
    end

    def subscribers
      Essential::Resource::PaginatorProxy.new(Essential::Messaging::Subscriber, headers: @headers)
    end

    def transports
      Essential::Resource::PaginatorProxy.new(Essential::Messaging::Transport, headers: @headers)
    end

    def messages
      Essential::Resource::PaginatorProxy.new(Essential::Messaging::Message, headers: @headers)
    end
  end
end
