module Essential::Messaging
  class Channel < Essential::Resource
    extend Essential::Resource::List
    include Essential::Resource::Update

    attr_property :name, :onreceived_url, :created_at, :updated_at
    attr_schema created_at: Time, updated_at: Time

    attr_relation account_sid: 'Essential::Account'

    def transports
      Essential::Resource::PaginatorProxy.new(
        Transport,
        params: {channel: self.sid},
        headers: @headers
      )
    end

    def subscribers
      Essential::Resource::PaginatorProxy.new(
        Subscriber,
        params: {channel: self.sid},
        headers: @headers
      )
    end

    def messages
      Essential::Resource::PaginatorProxy.new(
        Message,
        params: {channel: self.sid},
        headers: @headers
      )
    end

  end
end
