module Essential::Messaging
  class Transport < Essential::Resource
    extend Essential::Resource::List

    attr_property :protocol, :endpoint, :created_at, :updated_at
    attr_schema created_at: Time, updated_at: Time

    attr_unfiltered :channel

    attr_relation account_sid: 'Essential::Account'
    attr_relation channel_sid: 'Channel'

    def subscribers
      Essential::Resource::PaginatorProxy.new(
        Subscriber,
        params: {transport: self.sid},
        headers: @headers
      )
    end

    def messages
      Essential::Resource::PaginatorProxy.new(
        Message,
        params: {transport: self.sid},
        headers: @headers
      )
    end
  end
end
